from dune.codegen.generation import (backend,
                                     get_backend,
                                     generator_factory,
                                     )


@backend(interface="foo", name="f1")
@generator_factory()
def f1():
    return 1


@backend(interface="bar", name="f3")
@generator_factory()
def f3():
    return 3


def test_backend():
    assert get_backend(interface="foo", selector=lambda: "f1")() == 1
    assert get_backend(interface="bar", selector=lambda: "f3")() == 3
